import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Body here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Body extends Actor
{
    
   
    Arm arm = null;
    Leg leg = null;
    
    Arm_Back arm_back = null;
    Leg_Back leg_back = null;
    
    int rightPunch = 0;
    int leftPunch = 0;
    int walking = 0;
    boolean walkRight = false;
    
    
    public void setArm(Arm arm)
    {
        this.arm = arm;
    }
    
    public void setLeg(Leg leg)
    {
        this.leg = leg;
    }
    
    public void setArm_Back(Arm_Back arm_back)
    {
        this.arm_back = arm_back;
    }
    
    public void setLeg_Back(Leg_Back leg_back)
    {
        this.leg_back = leg_back;
    }
    
    private void MoveArmsAndLegs()
    {
        if(arm != null)
        {
            arm.setLocation(this.getX()+15,this.getY() - 14);
        }
        
        if(leg != null)
        {
            leg.setLocation(this.getX()+4,this.getY()+50);
        }

        if(arm_back != null)
        {
            arm_back.setLocation(this.getX()+17,this.getY() - 12);
        }
        
        if(leg_back != null)
        {
            leg_back.setLocation(this.getX()+4,this.getY()+52);
        }
 
    }
    
    @Override
    protected void addedToWorld(World world)
    {
        MoveArmsAndLegs();
    }
    
    /**
     * Act - do whatever the Body wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        //this.setLocation(this.getX() + 1,this.getY());
        
        String s = null;
        
        for(s = Greenfoot.getKey(); 
            null != s;
            s = Greenfoot.getKey())
        {
            if(s.compareToIgnoreCase("a") == 0)
            {
                if(leftPunch == 0)
                {
                    leftPunch = 1;
                }
            }
            
            if(s.compareToIgnoreCase("s") == 0)
            {
                if(rightPunch == 0)
                {
                    rightPunch = 1;
                }

            }
            
            /*High Punch*/
            if(s.compareToIgnoreCase("q") == 0)
            {
                if(leftPunch == 0)
                {
                    leftPunch = 1;
                    arm_back.setRotation(-30);
                }
            }
            
            if(s.compareToIgnoreCase("w") == 0)
            {
                if(rightPunch == 0)
                {
                    rightPunch = 1;
                    arm.setRotation(-30);
                }
            }
            
            
            if(s.compareToIgnoreCase("right") == 0)
            {
                walkRight = true;
                if(walking == 0)
                {
                    walking = 1;
                }
            }
            
            if(s.compareToIgnoreCase("left") == 0)
            {
                walkRight = false;
                if(walking == 0)
                {
                    walking = 1;
                }
            }
            
            if(s.compareToIgnoreCase("z") == 0)
            {
                if(leftPunch == 0)
                {
                    leftPunch = 1;
                    arm_back.setRotation(30);
                }
            }
            
            if(s.compareToIgnoreCase("x") == 0)
            {
                if(rightPunch == 0)
                {
                    rightPunch = 1;
                    arm.setRotation(30);
                }
            }
        }
        
        if(walking > 0)
        {
            if(walking > 3)
            {
                walking = 0;
                leg.num = 0;
                leg_back.num = 0;
            }
            else
            {
                if (walkRight)
                {
                  leg.AntiCycle();
                  leg_back.AntiCycle();
                  setLocation(getX() + 2,getY());
                }
                else
                {
                  leg.Cycle();
                  leg_back.Cycle();
                  setLocation(getX() - 2,getY());
                }
                walking++;
            }
        }
        
        if(leftPunch > 0)
        {
            if(leftPunch > 3)
            {
                leftPunch = 0;
                arm_back.num = 0;
                arm_back.setRotation(0);
            }
            else
            {
                arm_back.Cycle();
                leftPunch++;
            }

        }

        if(rightPunch > 0)
        {
            if(rightPunch > 3)
            {
                rightPunch = 0;
                arm.num = 0;
                arm.setRotation(0);
            }
            else
            {
                arm.Cycle();
                rightPunch++;
            }
        }
        
        MoveArmsAndLegs();
        
    }   
}
